
aca_init:
	bsr.s aca_enable

	tst.w $34(a0) ; maxmem on?
	bmi.s .noprotect ; was disabled
	tst.w $38(a0) ; protect on?
	bmi.s .acadone ; was enabled
.noprotect:

	; if protect is off or maxmem is off
	; clear F0 area completely.

	move.w d0,$34(a0) ;maxmem on
	move.w d0,$38(a0) ;protect off

	move.l #$f00000,a2
	move.w #524288/16-1,d2
	moveq #0,d3
.clearrom:
	move.l d3,(a2)+
	move.l d3,(a2)+
	move.l d3,(a2)+
	move.l d3,(a2)+
	dbf d2,.clearrom

.acadone:
	move.w d1,$38(a0) ;protect on
	move.w d0,$34(a0) ;maxmem on
	rts

aca_init_boot:
	bsr.s aca_enable
	move.w d1,$38(a0) ;protect on
	move.w d0,$34(a0) ;maxmem on
	rts

aca_enable:
	move.l #ACA_BASE,a0
	moveq #0,d0
	moveq #-1,d1
	move.w d1,(a0)
	move.w d0,4(a0)
	move.w d1,8(a0)
	move.w d1,$c(a0)
	move.w d0,$3c(a0) ;irqovl off
	rts	